-- name: \\#867c6f\\[CS] Lain
-- description: Present day... Present time!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

local TEXT_MOD_NAME = "Lain"
local TEXT_MOD_VERSION = "1.0"
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local TEX_LAIN = get_texture_info("lain-icon")

local VOICETABLE_LAIN = {
  [CHAR_SOUND_ATTACKED] = 'Lain_Dooh.ogg',
  [CHAR_SOUND_DOH] = 'Lain_Dooh.ogg',
  [CHAR_SOUND_DROWNING] = 'Lain_Drowning.ogg',
  [CHAR_SOUND_DYING] = 'Lain_HuhhHuh_LostaLife.ogg',
  [CHAR_SOUND_GROUND_POUND_WAH] = 'Lain_punch1.ogg',
  [CHAR_SOUND_HAHA] = 'Lain_HaHaa.ogg',
  [CHAR_SOUND_HAHA_2] = 'Lain_HaHaa.ogg',
  [CHAR_SOUND_HERE_WE_GO] = 'Lain_hereWeGo.ogg',
  [CHAR_SOUND_HOOHOO] = {'Lain_jump2.ogg', 'Lain_jump2.ogg'},
  [CHAR_SOUND_MAMA_MIA] = 'Lain_MammaMia.ogg',
  [CHAR_SOUND_OKEY_DOKEY] = 'Lain_okiedokie.ogg',
  [CHAR_SOUND_ON_FIRE] = 'Lain_Aaaaah_BurningIntoLava.ogg',
  [CHAR_SOUND_OOOF] = 'Lain_Huh_Oof.ogg',
  [CHAR_SOUND_OOOF2] = 'Lain_Huh_Oof.ogg',
  [CHAR_SOUND_PUNCH_HOO] = 'Lain_punch3.ogg',
  [CHAR_SOUND_PUNCH_WAH] = 'Lain_punch2.ogg',
  [CHAR_SOUND_PUNCH_YAH] = 'Lain_punch1.ogg',
  [CHAR_SOUND_SO_LONGA_BOWSER] = 'Lain_soLongBowser.ogg',
  [CHAR_SOUND_TWIRL_BOUNCE] = 'Lain_Shuaa_Boing.ogg',
  [CHAR_SOUND_WAAAOOOW] = 'Lain_FallingGreatHeight.ogg',
  [CHAR_SOUND_WAH2] = 'Lain_jump2.ogg',
  [CHAR_SOUND_WHOA] = 'Lain_Huh_Oof.ogg',
  [CHAR_SOUND_YAHOO] = 'Lain_jump4.ogg',
  [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'Lain_jump3.ogg',
  [CHAR_SOUND_YAH_WAH_HOO] = {'Lain_jump1.ogg', 'Lain_jump1.2.ogg'},
  [CHAR_SOUND_YAWNING] = 'Lain_Yawning.ogg',
  [CHAR_SOUND_PANTING] = {'Lain_1hpLeft.ogg', 'Lain_1hpLeft.ogg', 'Lain_1hpLeft.ogg'},
  [CHAR_SOUND_COUGHING1] = 'Lain_coughing.ogg',
  [CHAR_SOUND_COUGHING2] = 'silence.ogg',
  [CHAR_SOUND_COUGHING3] = 'Lain_coughing.ogg',
  [CHAR_SOUND_MAMA_MIA] = 'Lain_MammaMia.ogg',
  [CHAR_SOUND_IMA_TIRED] = 'Lain_ImaTired.ogg',
  [CHAR_SOUND_LETS_A_GO] = 'Lain_LetsGoAllTheWayIn.ogg',
  [CHAR_SOUND_HRMM] = 'Lain_grab.ogg',
  [CHAR_SOUND_UH2] = 'Lain_iDidit_pullingoverCorner.ogg',
  [CHAR_SOUND_UH2_2] = 'silence.ogg',
  [CHAR_SOUND_UH] = 'Lain_Uh.ogg',
  [CHAR_SOUND_PANTING_COLD] = {'Lain_1hpLeft.ogg', 'Lain_1hpLeft.ogg', 'Lain_1hpLeft.ogg'},
  [CHAR_SOUND_SNORING1] = 'silence.ogg',
  [CHAR_SOUND_SNORING2] = 'silence.ogg',
  [CHAR_SOUND_SNORING3] = 'silence.ogg',
  [CHAR_SOUND_EEUH] = 'Lain_iDidit_pullingoverCorner.ogg',
}

-- Load Models
local E_MODEL_LAIN = smlua_model_util_get_id("lain_geo")
local E_MODEL_LAIN2 = smlua_model_util_get_id("lain2_geo")
local E_MODEL_LAIN3 = smlua_model_util_get_id("lain3_geo")
local E_MODEL_LAIN4 = smlua_model_util_get_id("lain4_geo")
local E_MODEL_LAIN5 = smlua_model_util_get_id("lain5_geo")
local E_MODEL_LAIN6 = smlua_model_util_get_id("lain6_geo")
local E_MODEL_LAIN7 = smlua_model_util_get_id("lain7_geo")

-- Character Initialize
local CT_LAIN = _G.charSelect.character_add("Lain", "One of the many that exist...", "LukasATBK", {r = 134, g = 124, b = 111}, E_MODEL_LAIN, CT_MARIO, TEX_LAIN)

-- Add Voices
_G.charSelect.character_add_voice(E_MODEL_LAIN, VOICETABLE_LAIN)
_G.charSelect.character_add_voice(E_MODEL_LAIN2, VOICETABLE_LAIN)
_G.charSelect.character_add_voice(E_MODEL_LAIN3, VOICETABLE_LAIN)
_G.charSelect.character_add_voice(E_MODEL_LAIN4, VOICETABLE_LAIN)
_G.charSelect.character_add_voice(E_MODEL_LAIN5, VOICETABLE_LAIN)
_G.charSelect.character_add_voice(E_MODEL_LAIN6, VOICETABLE_LAIN)
_G.charSelect.character_add_voice(E_MODEL_LAIN7, VOICETABLE_LAIN)

-- Update Voicelines
local character_get_voice, update_sound, update_snore = _G.charSelect.character_get_voice, _G.charSelect.voice.sound, _G.charSelect.voice.snore
local function character_sounds(m, sound)
    local v = _G.charSelect.character_get_voice(m)
    if v == VOICETABLE_LAIN
    then
        return update_sound(m, sound)
    end
end
local function character_snore(m)
    local v = _G.charSelect.character_get_voice(m)
    if v == VOICETABLE_LAIN
    then
        return update_snore(m)
    end
end

hook_event(HOOK_CHARACTER_SOUND, character_sounds)
hook_event(HOOK_MARIO_UPDATE, character_snore)

--------------------------------------------
--- Alt Costume code from Paper Partners ---
-- Modified by Squishy for Azumanga Daioh --
--------------------------------------------

local character_edit = _G.charSelect.character_edit
local character_get_current_number = _G.charSelect.character_get_current_number
local character_get_current_table = _G.charSelect.character_get_current_table
local get_options_status = _G.charSelect.get_options_status
local get_menu_color = _G.charSelect.get_menu_color
local hook_render_in_menu = _G.charSelect.hook_render_in_menu

local table_insert = table.insert
local play_sound = play_sound
local djui_hud_get_screen_width = djui_hud_get_screen_width
local djui_hud_measure_text = djui_hud_measure_text
local djui_hud_set_color = djui_hud_set_color
local djui_hud_set_resolution = djui_hud_set_resolution
local djui_hud_set_rotation = djui_hud_set_rotation
local djui_hud_set_font = djui_hud_set_font
local djui_hud_print_text = djui_hud_print_text
local djui_hud_render_rect = djui_hud_render_rect
local maxf = maxf
local math_min = math.min
local math_max = math.max
local math_sin = math.sin

local altCostumes = {
    [CT_LAIN] = {
        currSkin = 1,
        {name = "", model = E_MODEL_LAIN,},
        {name = "White Dress", model = E_MODEL_LAIN2,},
        {name = "Casual", model = E_MODEL_LAIN3,},
        {name = "Casual (Capless)", model = E_MODEL_LAIN4,},
        {name = "Bear Pajamas", model = E_MODEL_LAIN5,},
        {name = "PSX", model = E_MODEL_LAIN6,},
        {name = "PSX (No Outline)", model = E_MODEL_LAIN7,},
    },
}

local function update_character_skin(currChar, currAlt)
    local currSkin = altCostumes[currChar][currAlt]
    if altCostumes[currChar].desc == nil then
        altCostumes[currChar].desc = character_get_current_table().description
    end
    local description = {}
    for i = 1, #altCostumes[currChar].desc do
        table_insert(description, altCostumes[currChar].desc[i])
    end
    if currSkin.name ~= "" then
        table_insert(description, "")
        table_insert(description, "Current Outfit: "..currSkin.name)
    end
    character_edit(currChar, nil, description, nil, nil, currSkin.model, nil, nil)
    local cameraToObject = gMarioStates[0].marioObj.header.gfx.cameraToObject
    play_sound(SOUND_MENU_MESSAGE_NEXT_PAGE, cameraToObject)
end

local inputLockTimer = 0
local buttonAnimTimer = 0

local MATH_DIVIDE_320 = 1/320

local latencyValueTable = {12, 6, 3}

local function hud_render()
    local width = djui_hud_get_screen_width() + 1.4
    local widthScale = maxf(width, 321.4) * MATH_DIVIDE_320
    local currChar = character_get_current_number()
    local charColors = character_get_current_table().color
    
    -- Mimick button swaying, which is missing from the paper code
    local buttonAnim = 0
    local charSelectAnim = get_options_status(_G.charSelect.optionTableRef.anims)
    if charSelectAnim > 0 then
        buttonAnimTimer = buttonAnimTimer + 1
        buttonAnim = math_sin(buttonAnimTimer * 0.05) * 2.5 + 5
    else
        buttonAnim = 10
    end

    local inputLockTimerTo = latencyValueTable[get_options_status(_G.charSelect.optionTableRef.inputLatency) + 1]

    if altCostumes[currChar] ~= nil then
        -- Render Mod Variond under CS version
        local menuColor = get_menu_color()
        djui_hud_set_color(menuColor.r, menuColor.g, menuColor.b, 255)
        djui_hud_set_font(FONT_TINY)
        local string = TEXT_MOD_NAME.." ("..TEXT_MOD_VERSION..")"
        djui_hud_print_text(string, width - 5 - djui_hud_measure_text(string)*0.5, 3, 0.5)

        ---@type Controller
        local c = _G.charSelect.controller
        local currAlts = altCostumes[currChar]

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local inputLockTimerAnim = 0

        local buttonX = 20 * widthScale + buttonAnim
        local x1 = buttonX - 4
        local x2 = x1 + 73
        local y = 97

        if charSelectAnim > 0 then
            inputLockTimerAnim = inputLockTimer/inputLockTimerTo * 3
            x1 = x1 + math_min(inputLockTimerAnim, 0)
            x2 = x2 + math_max(inputLockTimerAnim, 0)
        end
        -- Left Arrow
        if currAlts.currSkin > 1 then
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_set_rotation(0x2000, 0.5, 0.5)
            djui_hud_render_rect(x1, y, 5, 5)
            djui_hud_set_color(0, 0, 0, 255)
            djui_hud_set_rotation(0x0000, 0.5, 0.5)
            djui_hud_render_rect(x1 + 2.5, y - 2, 6, 8)
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_render_rect(buttonX, y - 3, 1, 10)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                currAlts.currSkin = math_max(currAlts.currSkin - 1, 1)
                update_character_skin(currChar, currAlts.currSkin)
                inputLockTimer = -inputLockTimerTo
            end
        end
        -- Right Arrow
        if currAlts.currSkin < #currAlts then
            -- Changed arrows to mimick the ones seen in the options menu
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_set_rotation(0x2000, 0.5, 0.5)
            djui_hud_render_rect(x2, y, 5, 5)
            djui_hud_set_color(0, 0, 0, 255)
            djui_hud_set_rotation(0x0000, 0.5, 0.5)
            djui_hud_render_rect(x2 - 3.5, y - 2, 6, 8)
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_render_rect(buttonX + 69, y - 3, 1, 10)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                currAlts.currSkin = currAlts.currSkin + 1
                update_character_skin(currChar, currAlts.currSkin)
                inputLockTimer = inputLockTimerTo
            end
        end
        -- use an input lock to prevent cycling too fast
        if inputLockTimer > 0 then
            inputLockTimer = inputLockTimer - 1
        elseif inputLockTimer < 0 then
            inputLockTimer = inputLockTimer + 1
        end
    end
end

hook_render_in_menu(hud_render)
